__author__ = 'Dan'
from pygame import Rect

class Camera(object):
    #Example camera = Camera(complex_camera, totalLevelWidth, totalLevelHeight, screenWidth, screenHeight)
    def __init__(self, camera_func, width, height, screenWidth, screenHeight):
        self.camera_func = camera_func
        self.state = Rect(0, 0, width, height)
        self.screen_width = screenWidth
        self.screen_height = screenHeight
        self.half_screen_width = self.screen_width / 2
        self.half_screen_height = self.screen_height / 2

    def apply(self, target):
        return target.rect.move(self.state.topleft)

    def update(self, target):
        self.state = self.camera_func(self.state, target.rect, self)

def simple_camera(camera_state, target_rect, camera):
    l, t, _, _ = target_rect
    _, _, w, h = camera_state
    return Rect(-l+camera.half_screen_width, -t+camera.half_screen_height, w, h)

def complex_camera(camera_state, target_rect, camera):
    l, t, _, _ = target_rect
    _, _, w, h = camera_state
    l, t, _, _ = -l+camera.half_screen_width, -t+camera.half_screen_height, w, h

    l = min(0, l)                           # stop scrolling at the left edge
    l = max(-(camera_state.width-camera.screen_width), l)   # stop scrolling at the right edge
    t = max(-(camera_state.height-camera.screen_height), t) # stop scrolling at the bottom
    t = min(0, t)                           # stop scrolling at the top
    return Rect(l, t, w, h)