#!/usr/bin/env python2
__author__ = 'Dan'

import pygame
from Map import Map, Tile
from Camera import Camera, simple_camera
import sys, csv

SCREEN_WIDTH = 600
SCREEN_HEIGHT = 600

global currentTileType
global totalLevelWidth

def Main():
    global currentTileType
    global totalLevelWidth
    def update():
        global currentTileType
        global totalLevelWidth
        time_passed = clock.tick(60) # default speed is 60fps
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            if event.type == pygame.KEYDOWN:
                """Keydown."""
                if event.key == pygame.K_ESCAPE:
                    sys.exit()
                if event.key == pygame.K_RIGHT:
                    """move right"""
                    target.vel += 10
                elif event.key == pygame.K_LEFT:
                    """move left"""
                    target.vel -= 10
                elif event.key == pygame.K_0:
                    currentTileType = "0"
                elif event.key == pygame.K_1:
                    currentTileType = "1"
                elif event.key == pygame.K_2:
                    currentTileType = "2"
                elif event.key == pygame.K_3:
                    currentTileType = "3"
                elif event.key == pygame.K_4:
                    currentTileType = "4"
                elif event.key == pygame.K_5:
                    currentTileType = "5"
                elif event.key == pygame.K_6:
                    currentTileType = "6"
                elif event.key == pygame.K_7:
                    currentTileType = "7"
                elif event.key == pygame.K_8:
                    currentTileType = "8"
                elif event.key == pygame.K_9:
                    currentTileType = "9"
                elif event.key == pygame.K_s:
                    saveMap()
                elif event.key == pygame.K_KP_PLUS:
                    for rowCount, row in enumerate(newmap.tiles):
                        row.append(Tile(len(row), rowCount, "9"))
                    totalLevelWidth = len(newmap.tiles[0]) * 60
                elif event.key == pygame.K_KP_MINUS:
                    for rowCount, row in enumerate(newmap.tiles):
                        row.pop()
                    totalLevelWidth = len(newmap.tiles[0]) * 60
                    pass
            elif event.type == pygame.KEYUP:
                """Key Up"""
                if event.key == pygame.K_RIGHT:
                    """stop moving right"""
                    target.vel = 0
                elif event.key == pygame.K_LEFT:
                    """stop moving left"""
                    target.vel = 0
            elif event.type == pygame.MOUSEBUTTONDOWN:
                mouseTile = getMouseTile()
                newmap.tiles[mouseTile[1]][mouseTile[0]].tileType = currentTileType
                newmap.tiles[mouseTile[1]][mouseTile[0]].texture = newmap.tilesets[newmap.currentTextureSet][currentTileType]


        target.rect.left += target.vel
        if target.rect.left < 0:
            target.rect.left = 0
            target.vel = 0
        if target.rect.right > totalLevelWidth:
            target.rect.right = totalLevelWidth
            target.vel = 0
        camera.update(target)


    def draw(screen, camera):
        global currentTileType
        global totalLevelWidth
        screen.fill((255,0,0))
        newmap.draw(screen, camera)
        mouseTile = getMouseTile()
        if mouseTile:
            dest = rectWrap(pygame.Rect(mouseTile, (60, 60)))
            screen.blit(source=newmap.tilesets[newmap.currentTextureSet][currentTileType], dest=camera.apply(newmap.tiles[mouseTile[1]][mouseTile[0]]))
        pygame.display.flip()

    def saveMap():
        csvFileName = "newMap.txt"
        with open(csvFileName, 'w') as outcsv:
            writer = csv.writer(outcsv, delimiter=',', lineterminator='\n')
            for row in newmap.tiles:
                writer.writerow([tile.tileType for tile in row])

    def getMouseTile():
        mousePos = pygame.mouse.get_pos()
        mouserect = rectWrap(pygame.Rect(mousePos, (1,1)))
        for rowCount, row in enumerate(newmap.tiles):
            for columnCount, tile in enumerate(row):
                if pygame.sprite.collide_rect(rectWrap(camera.apply(tile)), mouserect):
                    return (tile.x, tile.y)

    class rectWrap(object):
        def __init__(self, rect):
            self.rect = rect

    screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT), 0, 32)
    clock = pygame.time.Clock()
    newmap = Map()
    newmap.tilesets[newmap.currentTextureSet]["9"] = pygame.Surface((60,60))
    newmap.tilesets[newmap.currentTextureSet]["9"].fill((0,0,0))
    for rowCount, row in enumerate(newmap.tiles):
        for columnCount, tile in enumerate(row):
            newmap.tiles[rowCount][columnCount] = Tile(columnCount, rowCount, "9")

    totalLevelHeight = len(newmap.tiles) * 60
    totalLevelWidth = len(newmap.tiles[0]) * 60
    camera = Camera(simple_camera, totalLevelWidth, totalLevelHeight, 600, 600)
    target = pygame.sprite.Sprite()
    target.rect = pygame.Rect(300, 300, 1, 1)
    target.vel = 0
    mouseTile = None
    currentTileType = "9"


    while True:
        update()
        draw(screen, camera)



if __name__ == "__main__":
    Main()