__author__ = 'Dan'

from pygame import sprite, rect, time
from AnimatedSprite import AnimatedSprite
from resource_path import resource_path
import os

class Powerup(sprite.Sprite):
    types = ["Speed", "Jump", "Blue", "Red"]
    def __init__(self, powertype, position):
        sprite.Sprite.__init__(self)
        self.textures = dict()
        self.textures["Speed"] = AnimatedSprite(AnimatedSprite.load_sliced_sprites(60, 60, resource_path(os.path.join("resources","BluePowerupSheet.png"))))
        self.textures["Jump"] = AnimatedSprite(AnimatedSprite.load_sliced_sprites(60, 60, resource_path(os.path.join("resources","RedPowerupSheet.png"))))
        self.textures["Blue"] = AnimatedSprite(AnimatedSprite.load_sliced_sprites(60, 60, resource_path(os.path.join("resources","BlueDot60.png"))))
        self.textures["Red"] = AnimatedSprite(AnimatedSprite.load_sliced_sprites(60, 60, resource_path(os.path.join("resources","RedDot60.png"))))
        for type in self.types:
            if type == powertype:
                self.animated = self.textures[type]
        self.rect = rect.Rect(position, (60, 60))
        self.type = powertype
        self.image = None
        self.update(time.get_ticks())


    def update(self, t):
        self.animated.update(t)
        self.image = self.animated.image